#!/bin/sh
# Heavily based on Slackware 13.1 SlackBuild
#
# Slackware build script for xsel
# (http://www.vergenet.net/~conrad/software/xsel/)
#
# Copyright 2008 Corrado Franco (http://www.conraid.net)
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# re-packed for 13.0 by Luci0

# Exit on most errors
set -e 

# Set variables:
CWD=$(pwd)

PRGNAME=${PRGNAME:-xsel}		
VERSION=${VERSION:-1.2.0}	
ARCH=${ARCH:-i686}		
BUILD=${BUILD:-5}
TAG=${TAG:-sl}		
TMP=${TMP:-/tmp/txz-$PRGNAME-$VERSION} # If you use /tmp here, don't use --cleanup options	
JOBS=${JOBS:--j2}
SOURCE="http://www.vergenet.net/~conrad/software/xsel/download/xsel-${VERSION}.tar.gz"
PKG=$TMP/package-$PRGNAME
DOCS="$PKG/usr/doc/$PRGNAME-$VERSION"

# Insert document files in this variable
DOCFILES="AUTHORS COPYING ChangeLog README NEWS INSTALL"	


# Set compiling FLAGS
case "$ARCH" in
    i486)
	SLKCFLAGS="-O2 -march=i486 -mtune=i686"; CHOST="i486"
        ;;
    i686)
	SLKCFLAGS="-O2 -march=i686 -pipe -fomit-frame-pointer"; CHOST="i486"
        ;;
    x86_64)
	SLKCFLAGS="-O2 -fPIC -pipe -fomit-frame-pointer"; CHOST="x86_64"
        ;;
esac
                                                                                    


# Download source, if not exist
if ! [ -e $(basename $SOURCE) ]; then
    wget $SOURCE
fi

# Extract source and prepare:
rm -rf $PKG
mkdir -p $TMP $PKG
cd $TMP
rm -rf $PRGNAME-$VERSION

tar xzvf $CWD/$PRGNAME-$VERSION.tar.gz
cd $PRGNAME-$VERSION
                    
# Make sure ownerships and permissions are sane:
chown -R root:root .
chmod -R u+w,go+r-w,a-s .

# Configure
CFLAGS="$SLKCFLAGS" \
CXXFLAGS="$SLKCFLAGS" \
./configure \
  --prefix=/usr \
  --sysconfdir=/etc \
  --localstatedir=/var \
  --mandir=/usr/man \
  --infodir=/usr/info \
  --host=$CHOST-slackware-linux \
  --build=$CHOST-slackware-linux


# Build and install:
make $JOBS
make DESTDIR=$PKG install

# Strip binaries:
find $PKG | xargs file | grep -e "executable" -e "shared object"| grep ELF | \
  cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
  

# Compress and link manpages, if any:
if [ -d $PKG/usr/man ]; then
( cd $PKG/usr/man
  find . -type f -exec gzip -9 {} \;
  for i in $( find . -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
)
fi

# Add a documentation directory:
mkdir -p ${DOCS}
for i in ${DOCFILES}; do
    if [ -e ${i} ]; then
        if ! [ -L ${i} ]; then
	    cp -a ${i} ${DOCS}
	else
	    cp -LRp ${i} ${DOCS}
        fi
    fi;
done

# Add a slackbuild script:
cat $CWD/$PRGNAME.SlackBuild > $DOCS/$PRGNAME.SlackBuild

# Add slack-desc
mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
cat $CWD/slack-desc > $DOCS/slack-desc

# Create slack-required file:
if [ -x /usr/bin/requiredbuilder ]; then
    requiredbuilder -v -y -s $CWD $PKG
fi
    

# Create package:
cd $PKG
/sbin/makepkg -l y -c n $CWD/$PRGNAME-$VERSION-$ARCH-${BUILD}${TAG}.txz

# Clean file, if option is set: 
if [ "$1" = "--cleanup" ]; then
  rm -rf $TMP
fi
